#include "Garage.h"

Garage::Garage(void) : nbVehicules(0) { listeVehicules = (Vehicule**)malloc(sizeof(Vehicule*)); }

Garage::~Garage(void) {
	for (unsigned int i = 0; i < nbVehicules; ++i) {
		delete getVehicule(i);
	}
	free(listeVehicules);
}

int Garage::getNbVehicules(void) const {
	return nbVehicules;
}

Vehicule* Garage::getVehicule(int i) const {
	if (i >= getNbVehicules() || i < 0) {
		std::cout << "ERREUR Vous essayez d'accéder à un véhicule inexistant." << std::endl;
		return NULL;
	}
	else {
		return listeVehicules[i];
	}
}

void Garage::afficher(std::ostream &flux) const {
	if (getNbVehicules() == 0) {
		flux << "Le garage est vide :(" << std::endl;
	}
	else {
		flux << "Le garage contient " << getNbVehicules() << " véhicules." << std::endl;
		for (unsigned int i = 0; i < getNbVehicules(); ++i) {
			getVehicule(i)->afficher(flux);
		}
	}
}

void Garage::ajouterVehicule(Vehicule* ptrV) {
	Vehicule** tmp = (Vehicule**)malloc(getNbVehicules()*sizeof(Vehicule*));
	for (unsigned int i = 0; i < getNbVehicules(); ++i) { tmp[i] = getVehicule(i); }
	free(listeVehicules);
	nbVehicules++;
	listeVehicules = (Vehicule**)malloc(nbVehicules*sizeof(Vehicule*));
	for (unsigned int i = 0; i < getNbVehicules()-1; ++i) { listeVehicules[i] = tmp[i]; }
	free(tmp);
	listeVehicules[getNbVehicules()-1] = ptrV;
}

void Garage::ajouterVoiture(void) {
	int km, toit;
	double prix;
	std::cout << "Quel est son prix ?" << std::endl;
	std::cin >> prix;
	std::cout << "Quel kilométrage ?" << std::endl;
	std::cin >> km;
	std::cout << "A-t-elle un toit ouvrant ? (0 si oui)" << std::endl;
	std::cin >> toit;
	if (toit == 0) ajouterVehicule(new Voiture(km,prix,true));
	else ajouterVehicule(new Voiture(km,prix,false));
}

void Garage::ajouterDirigeable(void) {
	int km, alt;
	double prix;
	std::cout << "Quel est son prix ?" << std::endl;
	std::cin >> prix;
	std::cout << "Quel kilométrage ?" << std::endl;
	std::cin >> km;
	std::cout << "Quelle altitude maximale ?" << std::endl;
	std::cin >> alt;
	ajouterVehicule(new Dirigeable(km,prix,alt));
}

void Garage::gestion() {
	int choix = 0;
	do {
		std::cout << "Gestion du garage !" << std::endl;
		std::cout << "1- Afficher tous les véhicules. 2- Ajouter une voiture. 3- Ajouter un dirigeable. Autre- Quitter" << std::endl;
		std::cin >> choix;
		switch (choix) {
			case 1:
				afficher(std::cout);
				break;
			
			case 2:
				ajouterVoiture();
				break;
			
			case 3:
				ajouterDirigeable();
				break;
			
			default:
				choix = 0;
				break;
		}
	} while (choix != 0);
	std::cout << std::endl << "Merci !" << std::endl;
}

std::ostream& operator<<(std::ostream &flux, Garage const& g) {
	g.afficher(flux);
	return flux;
}
